/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <config.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include "comm.h"
#include "auth.h"
#include "parser.h"
#include "attack.h"

extern struct arglist * plugins;

void attack_host(hostname,max_hosts,recursive)
	char * hostname;
	int max_hosts;
	int recursive;
{
  char * plug_list;
  struct arglist * plugs = plugins;
  int num_plug = 0;
  
  while(plugs && plugs->next){
  	num_plug++;
  	plugs = plugs->next;
  	}
  plugs = plugins;
  plug_list = emalloc(num_plug*4+1);
  while(plugs && plugs->next)
  {
	  char * sp;
	  
	  if(arg_get_value(plugs->value, "ENABLED"))
	  {
	  
	  sp = emalloc(9);
	  sprintf(sp, "%d", (int)arg_get_value(plugs->value, "ID"));
	  strcat(plug_list, sp);
	  efree(sp);
	  strcat(plug_list, ";");
	  }
	  plugs = plugs->next;
   }
  if(!strlen(plug_list))sprintf(plug_list, "0");
  auth_printf("CLIENT <|> NEW_ATTACK <|> %s <|> %d <|> %d <|> %s <|> CLIENT\n",
	      plug_list,max_hosts, recursive, hostname);
  efree(plug_list);	     
  
}
