/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <config.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <gtk/gtk.h>

#include "attack.h"
#include "xstuff.h"
#include "comm.h"
#include "auth.h"
#include "parser.h"
#include "monitor_dialog.h"
#include "plugin_list.h"

struct attack_entries {
  GtkWidget * window;
  GtkWidget * hostname;
};

void attack_dialog_callback(GtkWidget * , struct attack_entries *);
void attack_input_callback(void * , int, int);
	
int attack_dialog_setup(hostname)
     char * hostname;
{
  struct attack_entries entries;
  GtkWidget * table;
  GtkWidget * button;
  GtkWidget * label;
  char * msg;
  
  
  entries.window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect(GTK_OBJECT(entries.window), "destroy", 
		     (GtkSignalFunc)close_window,entries.window);
  gtk_signal_connect(GTK_OBJECT(entries.window), "delete_event", 
		     (GtkSignalFunc)close_window,entries.window);		 
  gtk_window_set_title(GTK_WINDOW(entries.window), "Select host to test");
  gtk_container_border_width(GTK_CONTAINER(entries.window), 10);
  
  table = gtk_table_new(3, 3, TRUE);
  
  gtk_container_add(GTK_CONTAINER(entries.window), table);
  gtk_table_set_col_spacing(GTK_TABLE(table), 0, 15);
  gtk_table_set_col_spacing(GTK_TABLE(table), 1, 15);
  gtk_table_set_row_spacing(GTK_TABLE(table), 0,15);
  gtk_table_set_row_spacing(GTK_TABLE(table), 1,15);
  
  msg = emalloc(40+strlen(hostname));
  sprintf(msg, "Connected to %s", hostname);
  
  label = gtk_label_new(msg);
  gtk_table_attach_defaults(GTK_TABLE(table),label, 0,1,0,1);
  gtk_widget_show(label);
  
  label = gtk_label_new("Host to test :");
  gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,1,2);
  gtk_widget_show(label);
  
  entries.hostname = gtk_entry_new();
  gtk_table_attach_defaults(GTK_TABLE(table), entries.hostname, 1,3,1,2);
  gtk_widget_show(entries.hostname);
  
  button = gtk_button_new_with_label("Plugin list");
  gtk_signal_connect_object(GTK_OBJECT (button), "clicked", 
   	(GtkSignalFunc)plugin_list_setup,NULL);
  gtk_table_attach_defaults(GTK_TABLE(table), button, 0,1,2,3);
  gtk_widget_show(button);
  
  button = gtk_button_new_with_label("Cancel");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 1,2,2,3);
  gtk_signal_connect_object(GTK_OBJECT (button), "clicked", 
   	(GtkSignalFunc)close_window,(void *)entries.window);
  gtk_widget_show(button);
  
  button = gtk_button_new_with_label("Go !");
  gtk_table_attach_defaults(GTK_TABLE(table), button, 2,3,2,3);
  gtk_signal_connect_object(GTK_OBJECT (button), "clicked", 
			    (GtkSignalFunc)attack_dialog_callback,(void*)&entries);
  gtk_widget_show(button);
  gtk_widget_show(table);
  gtk_widget_show(entries.window);
  gtk_main();
  return(0);
}


void attack_dialog_callback(widget,entries)
     GtkWidget * widget;
     struct attack_entries * entries;
{
  char * hostname;
  char * t;
  
  t = gtk_entry_get_text(GTK_ENTRY(entries->hostname));
  hostname = emalloc(strlen(t)+1);
  strncpy(hostname, t, strlen(t));
  gtk_widget_hide(entries->window);
  monitor_dialog_setup(hostname);
}


