/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */
 
 
#include <config.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <gtk/gtk.h>

#include "attack_dialog.h"
#include "xstuff.h"
#include "nessus.h"

struct auth_entries {
  GtkWidget * window;
  GtkWidget * username;
  GtkWidget * password;
  GtkWidget * hostname;
  GtkWidget * port;
	};
	
	
void auth_dialog_callback(GtkWidget *, struct auth_entries *);
	

int auth_dialog_setup()
{
 struct auth_entries entries;
 GtkWidget * label;
 GtkWidget * button;
 GtkWidget * table;
 
 entries.window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
 gtk_window_set_title(GTK_WINDOW (entries.window), "Nessusd Host");
 gtk_signal_connect(GTK_OBJECT (entries.window), "destroy",
		    (GtkSignalFunc)close_window,entries.window);
 gtk_signal_connect(GTK_OBJECT(entries.window),"delete_event",
		    (GtkSignalFunc)close_window,entries.window);
 
 gtk_container_border_width(GTK_CONTAINER(entries.window), 10);
 
 table = gtk_table_new(6, 2, TRUE);
 gtk_container_add(GTK_CONTAINER (entries.window), table);
 
 gtk_table_set_col_spacing(GTK_TABLE(table), 0, 15);
 label = gtk_label_new("Nessusd Host : ");
 gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,0,1);
 gtk_widget_show(label);
 
 entries.hostname = gtk_entry_new_with_max_length (255);
 gtk_table_attach_defaults(GTK_TABLE(table), entries.hostname, 1,2,0,1);
 
 
 label = gtk_label_new("Port : ");
 gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,1,2);
 gtk_widget_show(label);
 
 entries.port = gtk_entry_new_with_max_length (255);
 gtk_table_attach_defaults(GTK_TABLE(table), entries.port, 1,2,1,2);
 /* gtk_widget_show(entries.port); */
 
 label = gtk_label_new("Login :");
 gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,2,3);
 gtk_widget_show(label);
 
 entries.username = gtk_entry_new_with_max_length (255);
 gtk_table_attach_defaults(GTK_TABLE(table), entries.username, 1,2,2,3);
 /* gtk_widget_show(entries.username); */
 
 label = gtk_label_new("Password : ");
 gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,3,4);
 gtk_widget_show(label);
 
 entries.password = gtk_entry_new_with_max_length (255);
 gtk_entry_set_visibility(GTK_ENTRY(entries.password), FALSE);
 gtk_table_attach_defaults(GTK_TABLE(table), entries.password, 1,2,3,4);
 /* gtk_widget_show(entries.password); */
 
 
 button = gtk_button_new_with_label("Cancel");
 gtk_signal_connect_object(GTK_OBJECT (button), "clicked", 
			   (GtkSignalFunc)close_window,(void*)entries.window);
 gtk_table_attach_defaults(GTK_TABLE(table), button, 0,1,5,6);
 gtk_widget_show(button);
 
 button = gtk_button_new_with_label("Connect");
 gtk_table_attach_defaults(GTK_TABLE(table), button, 1,2,5,6);
 gtk_signal_connect_object(GTK_OBJECT (button), "clicked",
			   (GtkSignalFunc)auth_dialog_callback,
			   (void *)&entries);
 gtk_widget_show(button);
 gtk_widget_show(entries.hostname);
 gtk_widget_show(entries.port);
 gtk_widget_show(entries.username);
 gtk_widget_show(entries.password);
 gtk_widget_show(table);
 gtk_widget_show(entries.window);
 gtk_main();
 return(0);
}
 
void auth_dialog_callback(widget, entries)
     GtkWidget * widget;
     struct auth_entries * entries;
{
  char * username;
  char * password;
  char * hostname;
  char * t;
  int port;
  int err;
  
  t = gtk_entry_get_text(GTK_ENTRY(entries->hostname));
  hostname = emalloc(strlen(t)+1);
  strncpy(hostname, t, strlen(t));
 
  port = atoi(gtk_entry_get_text(GTK_ENTRY(entries->port)));
 
  t = gtk_entry_get_text(GTK_ENTRY(entries->username));
  username = emalloc(strlen(t)+1);
  strncpy(username, t, strlen(t));
 
  t = gtk_entry_get_text(GTK_ENTRY(entries->password));
  password = emalloc(strlen(t)+1);
  strncpy(password, t, strlen(t));
 
  err = connect_to_nessusd(hostname, port, username, password);
  if(err)exit_clean(err);
  gtk_widget_hide(entries->window);
  attack_dialog_setup(hostname);
  return;
}
