/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Nessus Communication Manager -- it manages the NTP Protocol, version 1.0
 *
 */ 
 
#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <sys/socket.h>
#include "auth.h"
#include "comm.h" 
#include "parser.h"




extern struct arglist * plugins;

int comm_init(soc)
	int soc;
{  
  char * buf;
  /* stdin and stdout == soc */
  close(0);dup(soc);
  close(1);dup(soc);
  buf = emalloc(15);
  fgets(buf, 14, stdin);
  if(strncmp(buf, "< NTP/1.0 >", 11))return(-1);
  efree(buf);
  return(0);
}

void comm_terminate()
{
  shutdown(0,2);
}


int comm_get_pluginlist()
{
  char * buf;
  int flag = 0;

  buf = emalloc(4096);
  auth_gets(buf, 27);
  if(strncmp(buf, "SERVER <|> PLUGIN_LIST <|>", 27))return(-1);
  bzero(buf, 4096);
  while(!flag)
    {
      auth_gets(buf, 4095);
      if(!strncmp(buf, "<|> SERVER", 10))flag = 1;
      else
	{
	  char * str;
	  struct arglist * plugin;
	  int id;
	  size_t l;
	  
	  sscanf(buf, "%d", &id);
	 
#ifdef DEBUGMORE
	  fprintf(stderr, "buf : %s\nid : %d\n", buf, id);
#endif
	  plugin = emalloc(sizeof(struct arglist));
	  arg_add_value(plugin, "ID", ARG_INT, sizeof(int), (void *)id);
	  
	  str = parse_separator(buf);if(!str)continue;
	  arg_add_value(plugin, "NAME", ARG_STRING, strlen(str), str);
	  l = strlen(str) + 5;
	  str =  parse_separator(buf+l);if(!str)continue;
	  arg_add_value(plugin, "CATEGORY", ARG_STRING, strlen(str),str);
	
	  l += strlen(str) + 5;
	  str =  parse_separator(buf+l);if(!str)continue;
	  arg_add_value(plugin, "COPYRIGHT", ARG_STRING, strlen(str), str);
	  
	  l+= strlen(str) + 5;
	  
	  str = parse_separator(buf+l);if(!str)continue;
	  arg_add_value(plugin, "DESCRIPTION", ARG_STRING, strlen(str), str);
	  
	  l+= strlen(str) + 5;
	  
	  str = parse_separator(buf+l);if(!str)continue;
	  arg_add_value(plugin, "SUMMARY",ARG_STRING, strlen(str), str);
	  
	  l+= strlen(str) + 5;
	  
	  str = parse_separator(buf+l);if(!str)continue;
	  arg_add_value(plugin, "FAMILY", ARG_STRING, strlen(str),str);
	  
	  arg_add_value(plugin, "ENABLED", ARG_INT, sizeof(int), (void *)1);
	  arg_add_value(plugins, arg_get_value(plugin, "NAME"), ARG_ARGLIST, -1, plugin);
#ifdef DEBUG
	  fprintf(stderr, "%d : %s [%s] %s\n", (int)arg_get_value(plugin, "ID"),
	  			    (char *)arg_get_value(plugin, "NAME"),
	  			    (char *)arg_get_value(plugin, "COPYRIGHT"),
	  			    (char *)arg_get_value(plugin, "FAMILY"));
#endif
	}
    }
  return(0);
}



   
   



