/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This is the Authentification Manager
 *
 * This authentification scheme is BADLY written, and should NOT
 * be used in the future
 */


#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdlib.h>
#include <stdio.h> 
#include <stdarg.h>
#include <fcntl.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <sys/types.h>
#include <sys/socket.h> 
#include <signal.h>
#include <time.h>
#include <sys/time.h>

#include "comm.h"
#include "auth.h"
#include "log.h"
#include "sighand.h"

int auth_check_user(from)
   char * from;
{
  char * buf_user, * buf_password;
  int good = 0;

  
  buf_user = emalloc(20);
  buf_password = emalloc(20);
  
  auth_printf("User : ");
  auth_gets(buf_user, 19);
  
  auth_printf("Password : ");
  auth_gets(buf_password, 19);
  
  buf_user[strlen(buf_user)-1]=0;
  buf_password[strlen(buf_password)-1]=0;
  if(!strcmp(USER, buf_user) && !strcmp(PASS, buf_password))
  {
   good = 1;
   log_write("successful login of %s from %s\n", USER, from);
  }
  efree(buf_user);
  efree(buf_password);
  return(0);
}


void auth_printf(char * data, ...)
{
  va_list param;
  
  signal(SIGPIPE, sighand_pipe);
  va_start(param, data);
  vfprintf(stdout, data, param);
  fflush(stdout);
  signal(SIGPIPE, SIG_IGN);
}                    

char * auth_gets(s,size)
     char * s;
     int size;
{
  bzero(s, size);
  signal(SIGALRM, sighand_alarm);
  alarm(CLIENT_TIMEOUT);
  signal(SIGPIPE, sighand_pipe);
  fgets(s, size, stdin);
  if(!strlen(s)){
  	log_write("connection closed by the client");
  	log_write("exiting");
  	exit(0);
  	}
  /* we will have to decrypt some stuff here !*/
  signal(SIGALRM, SIG_IGN);
  signal(SIGPIPE, SIG_IGN);
  alarm(0);
  return(s);
}

int auth_gets_nonblock(s, size)
     char * s;
     int size;
{
  fd_set fd_read;
  struct timeval timewait = {1,0};
  
  FD_ZERO(&fd_read);
  FD_SET(0, &fd_read);
  select(1, &fd_read, NULL, NULL, &timewait); 
  select(0,NULL,NULL,NULL,&timewait);
  if(FD_ISSET(0, &fd_read))
  {
   fgets(s, size, stdin);
   return(0);
  }
  else
  return(-1);
 }
