#include <config.h>
#include <nessuslib.h>
#include <nessus-devel.h>

#include "log.h"
#include "auth.h"
#include "nmap.h"
#include <errno.h>

/*
 * This code was ripped from Fyodor <fyodor@dhp.com> -- you may thank him
 * a lot.
 */

 
/* global options */
int number_of_ports  = 0; /* How many ports do we scan per machine? */



int nmap_main(hostinfos)
     struct arglist * hostinfos;
{
  short *ports;
  portlist openports = NULL;
  struct in_addr *p_addr;
  
  ports = getpts("1-8001");
  p_addr = arg_get_value(hostinfos, "IP");
  if(!p_addr)return(-1);
#if 0
  if(getuid()==0)
    {
      if(isup(*p_addr))
	tcp_scan(*p_addr, ports, &openports, 
		 arg_get_value(hostinfos, "PORTS"));
      else log_write("%s appears to be down -- no scan\n", 
		     (char *)arg_get_value(hostinfos, "FQDN"));
    }
  else 
#endif
    tcp_scan(*p_addr, ports, &openports, hostinfos);
  return 0;
}

__inline__ int unblock_socket(sd)
     int sd;
{
  int options;
  /*Unblock our socket to prevent recvfrom from blocking forever 
    on certain target ports. */
  options = O_NONBLOCK | fcntl(sd, F_GETFL);
  fcntl(sd, F_SETFL, options);
  return 1;
}

__inline__ int block_socket(sd)
     int sd;
{
  int options;
  options = (~O_NONBLOCK) & fcntl(sd, F_GETFL);
  fcntl(sd, F_SETFL, options);
  return 1;
}

/* Currently only sets SO_LINGER, I haven't seen any evidence that this
   helps.  I'll do more testing before dumping it. */
__inline__ void init_socket(sd) 
     int sd;
{
  struct linger l;
  
  l.l_onoff = 1;
  l.l_linger = 0;
  
  if (setsockopt(sd, SOL_SOCKET, SO_LINGER,  &l, sizeof(struct linger)))
    {
      log_write("Problem setting socket SO_LINGER, errno: %d\n", errno);
      perror("setsockopt");
    }
}



portlist tcp_scan(target,portarray, ports,hostdata) 
     struct in_addr target;
     unsigned short *portarray;
     portlist *ports;
     struct arglist * hostdata;	   
{
  
  int starttime, current_out = 0, res , deadindex = 0, i=0, j=0, k=0, max=0; 
  struct sockaddr_in sock, stranger;
  int sockaddr_in_len = sizeof(struct sockaddr_in);
  int sockets[MAX_SOCKETS], deadstack[MAX_SOCKETS];
  unsigned short portno[MAX_SOCKETS];
  char owner[513], buf[65536]; 
  int current_socket /*actually it is a socket INDEX*/;
  fd_set fds_read, fds_write;
  struct timeval nowait = {0,0},  longwait = {7,0}; 
  int num_scanned = 0;
  if(!hostdata)return(*ports);
#ifdef DEBUGMORE
  printf("We are in TCP_SCAN\n");
#endif
  signal(SIGPIPE, SIG_IGN); /* ignore SIGPIPE so our 'write 0 bytes' test
			       doesn't crash our program!*/
  owner[0] = '\0';
  starttime = time(NULL);
  bzero((char *)&sock,sizeof(struct sockaddr_in));
  sock.sin_addr.s_addr = target.s_addr;
  sock.sin_family=AF_INET;
  FD_ZERO(&fds_read);
  FD_ZERO(&fds_write);
  auth_printf("SERVER <|> STAT <|> %s <|> 0/8000 <|> SERVER\n",arg_get_value(hostdata, "FQDN"));
  
  /* Initially, all of our sockets are "dead" */
  for(i = 0 ; i < MAX_SOCKETS; i++) {
    deadstack[deadindex++] = i;
    portno[i] = 0;
  }
  
  deadindex--; 
  /* deadindex always points to the most recently added dead socket index */
  
  while(portarray[j]) {
    longwait.tv_sec = 7;
    longwait.tv_usec = nowait.tv_sec = nowait.tv_usec = 0;
    
    for(i=current_out; i < MAX_SOCKETS && portarray[j]; i++, j++, num_scanned++) {
   
      if(num_scanned==100){
      	auth_printf("SERVER <|> STAT <|> %s <|> %d/8000 <|> SERVER\n",
      			arg_get_value(hostdata, "FQDN"), portarray[j]>0?portarray[j]-1:0);
      	num_scanned = 0;
      	}
      current_socket = deadstack[deadindex--];
      if ((sockets[current_socket] = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1)
	{perror("Socket troubles"); exit(1);}
      if (sockets[current_socket] > max) max = sockets[current_socket]; 
      current_out++;
      unblock_socket(sockets[current_socket]);
      init_socket(sockets[current_socket]);
      portno[current_socket] = portarray[j];
      sock.sin_port = htons(portarray[j]);
      if ((res = connect(sockets[current_socket],(struct sockaddr *)&sock,
			 sizeof(struct sockaddr)))!=-1)
	{
	printf("WTF???? I think we got a successful connection in non-blocking!!@#$\n");
         auth_printf("SERVER <|> PORT <|> %s <|> %d <|> SERVER\n",
			  arg_get_value(hostdata, "FQDN"),portarray[j]);
	}
      else {
	switch(errno) {
	case EINPROGRESS: /* The one I always see */
	case EAGAIN:
	  block_socket(sockets[current_socket]);
	  FD_SET(sockets[current_socket], &fds_write);
	  FD_SET(sockets[current_socket], &fds_read);
	  break;
	default:
	  printf("Strange error from connect: (%d)", errno);
	  perror(""); /*falling through intentionally*/
	case ECONNREFUSED:
	  if (max == sockets[current_socket]) max--;
	  deadstack[++deadindex] = current_socket;
	  current_out--;
	  portno[current_socket] = 0;
	  close(sockets[current_socket]);
	  break;
	}
      }
    }
    if (!portarray[j]) sleep(1); /*wait a second for any last packets*/
    while((res = select(max + 1, &fds_read, &fds_write, NULL, 
			(current_out < MAX_SOCKETS)?
			&nowait : &longwait)) > 0) {
      for(k=0; k < MAX_SOCKETS; k++)
	if (portno[k]) {
	  if (FD_ISSET(sockets[k], &fds_write)
	      && FD_ISSET(sockets[k], &fds_read)) {
	    res = recvfrom(sockets[k], buf, 65536, 0, (struct sockaddr *)
			   & stranger, &sockaddr_in_len);
	    if (res >= 0) {
	      host_add_port(hostdata, portno[k], 1, "");	    
	      auth_printf("SERVER <|> PORT <|> %s <|> %d <|> SERVER\n",
			  arg_get_value(hostdata, "FQDN"),portno[k]); 
	    }
	    if (max == sockets[k])
	      max--;
	    FD_CLR(sockets[k], &fds_read);
	    FD_CLR(sockets[k], &fds_write);
	    deadstack[++deadindex] = k;
	    current_out--;
	    portno[k] = 0;
	    close(sockets[k]);
	  }
	  else if(FD_ISSET(sockets[k], &fds_write)) {
	    res = send(sockets[k], buf, 0, 0);
	    if (res < 0 ) {
	      signal(SIGPIPE, SIG_IGN);
	    }
	    else {	    
	      host_add_port(hostdata, portno[k], 1, "");	    
	      auth_printf("SERVER <|> PORT <|> %s <|> %d <|> SERVER\n",
			  arg_get_value(hostdata, "FQDN"),portno[k]); 
	    }
	    if (max == sockets[k]) max--;
	    FD_CLR(sockets[k], &fds_write);
	    deadstack[++deadindex] = k;
	    current_out--;
	    portno[k] = 0;
	    close(sockets[k]);
	  }
	  else if ( FD_ISSET(sockets[k], &fds_read) ) {       
	    printf("Socket at port %hi is selectable for r only.  This is very weird.\n", portno[k]);
	    if (max == sockets[k]) max--;
	    FD_CLR(sockets[k], &fds_read);
	    deadstack[++deadindex] = k;
	    current_out--;
	    portno[k] = 0;
	    close(sockets[k]);
	  }
	  else {
	    FD_SET(sockets[k], &fds_write);
	    FD_SET(sockets[k], &fds_read);
	  }
	}
    }
  }
  return *ports;
}



unsigned short *getpts(origexpr) 
	char *origexpr;
{
int exlen = strlen(origexpr);
char *p,*q;
unsigned short *tmp, *ports;
int i=0, j=0,start,end;
char *expr = strdup(origexpr);
char *mem = expr;

ports = emalloc(65536 * sizeof(short));
for(;j < exlen; j++) 
  if (expr[j] != ' ') expr[i++] = expr[j]; 
expr[i] = '\0';
exlen = i;
i=0;
while((p = strchr(expr,','))) {
  *p = '\0';
  if (*expr == '-') {start = 1; end = atoi(expr+ 1);}
  else {
    start = end = atoi(expr);
    if ((q = strchr(expr,'-')) && *(q+1) ) end = atoi(q + 1);
    else if (q && !*(q+1)) end = 65535;
  }
  if (start < 1 || start > end) fatal("Your port specifications are illegal!");
  for(j=start; j <= end; j++) 
    ports[i++] = j;
  expr = p + 1;
}
if (*expr == '-') {
  start = 1;
  end = atoi(expr+ 1);
}
else {
  start = end = atoi(expr);
  if ((q =  strchr(expr,'-')) && *(q+1) ) end = atoi(q+1);
  else if (q && !*(q+1)) end = 65535;
}
if (start < 1 || start > end) fatal("Your port specifications are illegal!");
for(j=start; j <= end; j++) 
  ports[i++] = j;
number_of_ports = i;
ports[i++] = 0;
tmp = realloc(ports, i * sizeof(short));
  free(mem);
  return tmp;
}


#if 0

int isup(struct in_addr target) {
  int res, retries = 3;
  struct sockaddr_in sock;
  /*type(8bit)=8, code(8)=0 (echo REQUEST), checksum(16)=34190, id(16)=27002 */
  unsigned char ping[64] = { 0x8, 0x0, 0x8e, 0x85, 0x69, 0x7A };
  int sd;
  struct timeval tv;
  struct timeval start, end;
 fd_set fd_read;
  struct {
    struct iphdr ip;
    unsigned char type;
    unsigned char code;
    unsigned short checksum;
    unsigned short identifier;
    char crap[16536];
  }  response;

sd = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);

bzero((char *)&sock,sizeof(struct sockaddr_in));
sock.sin_family=AF_INET;
sock.sin_addr = target;
gettimeofday(&start, NULL);
while(--retries) {
  if ((res = sendto(sd,(char *) ping,64,0,(struct sockaddr *)&sock,
		    sizeof(struct sockaddr))) != 64) {
    log_write("sendto in isup returned %d! skipping host.\n", res);
    close(sd);
    return 0;
  } 
  FD_ZERO(&fd_read);
  FD_SET(sd, &fd_read);
  tv.tv_sec = 0; 
  tv.tv_usec = 1e6 * (PING_TIMEOUT / 3.0);
  while(1) {
    if ((res = select(sd + 1, &fd_read, NULL, NULL, &tv)) != 1) 
      break;
    else {
      read(sd,&response,sizeof(response));
      if  (response.ip.saddr == target.s_addr &&  !response.type 
	   && !response.code   && response.identifier == ntohs(27002)) {
	gettimeofday(&end, NULL);
	/* global_rtt = (end.tv_sec - start.tv_sec) * 1e6 + end.tv_usec - start.tv_usec;*/
	/* ouraddr.s_addr = response.ip.daddr; */
	close(sd);
	return 1;       
      }
    }
  }
}
 close(sd);
 return 0;
} 


#endif




