/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */  
 
#ifndef __NESSUS_RULES_H__
#define __NESSUS_RULES_H__

struct nessus_rules
	{
	char * name;
	short category; 
	struct nessus_rules * next;
	};
	
#define p_NOTHING 0	/*      nothing					*/
#define p_DONT_TEST 2	/*	n:hostname				*/
#define p_DO_TEST 4	/*	y:hostname -- bypasses DONT_TEST	*/

/* unimplemented yet */
#define p_DONT_DNS 8    /*	d:hostname				*/
#define p_DONT_SM 16	/*	s:hostname				*/


#define pTEST(a) (!((a) & p_DONT_TEST) || ((a) & p_DO_TEST))

/*
#define pDNS(a)  (!((a) & p_DONT_DNS))
#define pSM(a)	 (!((a) & p_DONT_SM))
*/


void rules_init();
struct nessus_rules * rules_parse(char * , struct nessus_rules *);
short get_hostname_attributes(char *);
char * rules_get_fname();


	
#endif
