/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Signals handler
 */

#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h> 
#include "log.h"
#include "auth.h"
extern int attack_num_daemons;

void sighand_pipe()
{
  log_write("connection closed by the client (SIGPIPE caught)\n");
  shutdown(0,2);
  close(0);
  _exit(1);   
}

void sighand_chld()
{
  while(wait3(NULL, WNOHANG, NULL)>0);
}

void sighand_chld2()
{
  while(wait3(NULL, WNOHANG, NULL)>0);
  attack_num_daemons--;
}

void sighand_alarm()
{
  log_write("connection timed out\n");
  shutdown(0,2);
  close(0);
  _exit(1);
}           

void sighand_alarm_plugin()
{
 extern pid_t current_plugin;
 log_write("current plugin is slow to finish -- sending SIGKILL\n");
 kill(current_plugin, SIGKILL);
}


void sighand_term()
{
  log_write("received the TERM signal\n");
  exit(0);
 }

void sighand_segv()
{
 log_write("SIGSEGV occured !\n");
 exit(0);
}

void sighand_io()
{
 char * buf;
 fprintf(stderr, "Received something -- trying to read it\n");
 buf = emalloc(4096);
 auth_gets(buf, 4095);
 fprintf(stderr, "Received : %s\n", buf);
}

