#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>  

#define NAME "finger features"
#define DESC "This plugin determines whether there's a hole in the fingerd \
daemon of a remote host, allowing a remote user to gain the list of the users \
who have never logged in the remote system"
#define COPYRIGHT "no copyright"
#define SUMM "determines if fingerd sends the list of the unused accounts of the remote system"


int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "finger abuses");
	return(0);
}


int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	
	int soc;
	char * buffer;
	
	if(host_get_port_state(args, 79)<=0)return(0);  
	soc = open_sock_tcp(args, 79);
	if(!soc)return(0);
	buffer = emalloc(1024);
	sprintf(buffer, ".\n");
	send(soc, buffer, strlen(buffer),0);
	bzero(buffer,1024);
	recv(soc, buffer, 1023,0);
	close(soc);
	if(!strstr(buffer, "such user")&&!strstr(buffer, "???"))
	{ 
	 char * report = emalloc(300+strlen(buffer));
	 sprintf(report,
"The finger daemon of the remote host is 
subject to the .@host fingerd bug.
Here is the output of this command :
%s\nSolution : upgrade your finger daemon or rease the line 
'finger' in /etc/inetd.conf if you don't use this service", buffer);
	 post_hole(args, 79, report);
	} 
	else
	{
	soc = open_sock_tcp(args, 79);
	sprintf(buffer, "0\n");
	send(soc, buffer, strlen(buffer),0);
	bzero(buffer,1024);
	recv(soc, buffer, 1023,0);
	close(soc);
	if(!strstr(buffer, "such user")&&!strstr(buffer, "???"))
	{ 
	 char * report = emalloc(300+strlen(buffer));
	 sprintf(report,
"The finger daemon of the remote host is 
subject to the 0@host fingerd bug.
Here is the output of this command :
%s\nSolution : upgrade your finger daemon or rease the line 
'finger' in /etc/inetd.conf if you don't use this service", buffer);
	 post_hole(args, 79, report);
	} 
	}
	efree(buffer);
	return(0);
	
}

