#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>

#define NAME "finger-cgi tester"
#define DESC "This plugins determines whether the 'finger' cgi is installed \
This cgi may lead to a denial of service of a remote server and may give \
some interesting informations to an intruder"
#define COPYRIGHT "ported by Renaud Deraison"
#define SUMM "determines the presence of the 'finger' cgi"



int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "CGI abuses");
	return(0);
}

int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	
	if(host_get_port_state(args, 80)<=0)return(0);
	
	if((is_cgi_installed(args, "finger")))
	{
	post_info(args, 80, "The 'finger' cgi is present\n+ This may give away some\
 informations to an intruder\n+ This may lead to a denial of service");
	}
	return(0);
}

