#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>   
#define NAME "wu-ftpd site exec bug"
#define DESC "This plugin determines whether a host can be subject to \
the 'site exec' bug which can allow a local user to gain root"
#define COPYRIGHT "no copyright"
#define SUMM "checks if the 'site exec' feature is present"





int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "FTP");
	return(0);
}
	

int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	int soc;
	char * buf;
	
	
	if(host_get_port_state(args, 21)<=0)return(0);
	soc = open_sock_tcp(args, 21);
	if(soc<0)return(-1);
	buf = emalloc(4096);
	
	recv(soc, buf, 4,0);
        recv(soc, buf+4, 4095,0);    
	
	bzero(buf,4096);
	sprintf(buf, "USER ftp\n");
	send(soc, buf, strlen(buf),0);
	bzero(buf,4095);
	recv(soc, buf, 4,0);
	recv(soc, buf+4, 4096,0);
	
	bzero(buf,4096);
	sprintf(buf, "PASS joe@\n");
	send(soc, buf, strlen(buf),0);
	bzero(buf,4096);
	recv(soc, buf, 4,0);
	recv(soc, buf+4, 4096,0);
	
	bzero(buf,4096);
	sprintf(buf, "SITE exec /bin/sh -c /bin/id\n");
	send(soc, buf, strlen(buf),0);
	bzero(buf,4095);
	recv(soc, buf, 4,0);
	recv(soc, buf+strlen(buf), 4096,0);
	
	if(strstr(buf, "uid"))
	{
	 char * report = emalloc(200+strlen(buf));
	 
	 sprintf(report, 
"The 'site exec' bug is present on the remote server 
any local user can easily gain root, and it's possible
to execute commands remotely.
/bin/sh -c /bin/id gives :\n%s
Solution : upgrade your wu-ftpd to a recent version", buf);
	
	post_hole(args, 21, report);
	efree(report);
       }
        efree(buf);
        close(soc);
	return(0);
}

