#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>   

#define NAME "nfs world export check"
#define DESC "This plugin determines if a given host \
exports its filesystem to anyone"
#define COPYRIGHT "no copyright"
#define SUMM "check if a host exports a filesystem to anyone"


extern int showmount(char *hostname, char **result);


int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Remote file access");
	return(0);
}
	

int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
  int res;
  char * data;
  
 if(host_get_port_state(args, 2049)<=0)return(0);
  
  res = !(showmount(plug_get_hostname(args), &data));
  if (res)
  {
   if (strstr(data, "(everyone)"))
   	{
   	char * report = emalloc(strlen(data)+50);
   	sprintf(report, "Some filesystems are exported to __everyone__\n%s", data);
   	post_hole(args, 2049,report);
   	efree(report);
   	efree(data);
  }
  }
  return(0);
}
